<?php
namespace App\Controllers\V2;

use App\Controllers\BaseController;
use App\Libraries\Common;
use App\Libraries\MyUpload;
use App\Libraries\NaverApiClient;
use App\Models\common\CodeModel;
use App\Models\results\M415Model;
use App\Models\v2\M705Model;
use App\Models\v2\M710Model;

class M705 extends BaseController
{

    private $model, $codeModel;

    public function __construct()
    {
        $this->model = new M705Model();
        $this->codeModel = new CodeModel();
    }

    public function lists(): string
    {
        $codes = $this->codeModel->getCodeLists(['STEP_VERIFICATION', 'VRFCREQ_WAY', 'CP_ID', 'TEL_FAIL_CAUSE', 'ARTICLE_TYPE']); // 코드조회
        $sido = $this->model->getAreaList(); // 지역조회
        $bonbu = $this->model->getBonbuList();
        $team = $this->model->getTeamList();
        $user = $this->model->getUserList();

        $this->data['sido'] = $sido;
        $this->data['bonbu'] = $bonbu;
        $this->data['team'] = $team;
        $this->data['user'] = $user;
        $this->data['codes'] = $codes;

        return view("pages/v2/m705/lists", $this->data);
    }

    public function getResultList()
    {
        $start = (int) $this->request->getGet('start') ?: 0;
        $end = (int) $this->request->getGet('length') ?: 10;

        $data = [
            'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
            'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
            'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
            'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
            'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
            'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
            'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
            'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
            'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
            'srcSido' => $this->request->getGet('srcSido'), // 시도
            'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
            'srcDong' => $this->request->getGet('srcDong'), // 읍면동
            'bonbu' => $this->request->getGet('bonbu'), // 본부
            'team' => $this->request->getGet('team'), // 팀
            'damdang' => $this->request->getGet('damdang'), // 담당
            'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
            'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
            'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
            'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
            'chk_spc_yn' => $this->request->getGet('chk_spc_yn'), // 면적여부
            'reference_file_url_yn' => $this->request->getGet('reference_file_url_yn'), // 참고용
            'corp_own' => $this->request->getGet('corp_own'), // 법인
        ];

        $totalCount = $this->model->getTotalCount($data);


        $datas = $this->model->getResultList($start, $end, $data);

        return $this->response->setJSON(body: [
            'recordsTotal' => $totalCount,
            'recordsFiltered' => $totalCount,
            'data' => $datas,
        ]);
    }

    // 배정확인
    public function getNotAssign()
    {
        try {

            $res = $this->model->getNotAssign();

            if (empty($res)) {
                return $this->response->setJSON([
                    'code' => '9',
                    'msg' => '미배정건이 존재하지 않습니다.'
                ]);
            }

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success',
                'res' => $res['vr_sq'],
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }

    // 엑셀 다운로드
    public function excel()
    {
        try {

            $data = [
                'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
                'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
                'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
                'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
                'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
                'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
                'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
                'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
                'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
                'srcSido' => $this->request->getGet('srcSido'), // 시도
                'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
                'srcDong' => $this->request->getGet('srcDong'), // 읍면동
                'bonbu' => $this->request->getGet('bonbu'), // 본부
                'team' => $this->request->getGet('team'), // 팀
                'damdang' => $this->request->getGet('damdang'), // 담당
                'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
                'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
                'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
                'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
                'chk_spc_yn' => $this->request->getGet('chk_spc_yn'), // 면적여부
                'reference_file_url_yn' => $this->request->getGet('reference_file_url_yn'), // 참고용
                'corp_own' => $this->request->getGet('corp_own'), // 법인
            ];

            $datas = $this->model->getExcelList($data);

            return $this->response->setJSON(body: [
                'data' => $datas,
            ]);

        } catch (\Exception $e) {
            $e->getPrevious()->getTraceAsString();
        }
    }


    // 상세화면
    public function detail($id)
    {
        $naver = new NaverApiClient();
        $id = (string) $id;

        if ($id === '') {
            throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound();
        }

        $codes = $this->codeModel->getCodeLists(['VRFCREQ_WAY', 'CONFIRM_RESULT_D11', 'CONFIRM_RESULT_T11', 'TRADE_TYPE', 'CERT_UNCNFRM_STATUS']); // 코드조회

        $data = $this->model->getDetail($id);
        $record = $this->model->getRecordInfo($id, '1');	// 홍보확인서
        $regist = $this->model->getRecordInfo($id, '2');	// 등기부등본
        $memo = $this->model->getMemo($id); // 메모
        $display = $this->model->getDisplay('M705_detail');
        $reference = $this->model->getAllRecordInfo($id, '7');	//참고용파일 (2017.09.26 추가)

        $hscp_info = [];
        if (!empty($data['hscp_no'])) {
            $apt_rlet_type_cd = ['A01', 'A02', 'A03', 'A04', 'B01', 'B02', 'B03'];
            $villa_rlet_type_cd = ['A05', 'A06'];


            if (in_array($data['rlet_type_cd'], $apt_rlet_type_cd)) { // apt 단지
                $detail_hscp = $naver->aptDetail($data['hscp_no']);
            }

            if (in_array($data['rlet_type_cd'], $villa_rlet_type_cd)) { // villa 단지
                $detail_hscp = $naver->villaDetail($data['hscp_no']);
            }

            $hscp_info = $detail_hscp['result'];

        }

        $this->data['codes'] = $codes;
        $this->data['data'] = $data;
        $this->data['record'] = $record;
        $this->data['regist'] = $regist;
        $this->data['memo'] = $memo;
        $this->data['display'] = $display;
        $this->data['reference'] = $reference;
        $this->data['detail_hscp'] = $hscp_info;

        return view("pages/v2/m705/detail", $this->data);
    }

    // 이미지회전
    public function rotateImage()
    {
        $common = new Common();

        try {

            $vr_sq = $this->request->getPost('vr_sq');
            $degress = $this->request->getPost('degress');

            if (empty($degrees) || !is_numeric($degrees)) {
                $degrees = 90;
            }

            $regist = $this->model->getRecordInfo($vr_sq, '2');
            $fullPath = $regist['file_path'] . $regist['file_name'];
            $fullPath = $_SERVER['DOCUMENT_ROOT'] . $common->realpath_to_webpath($fullPath);

            $degrees = (float) $degrees;

            $im = new \Imagick($fullPath);

            // 배경색(회전 시 빈 공간 채우는 색). 투명 원하면 'transparent'
            $im->setImageBackgroundColor(new \ImagickPixel('white'));

            // 회전
            $im->rotateImage($im->getImageBackgroundColor(), $degrees);

            // 포맷/압축 유지(옵션)
            $im->setImageCompressionQuality(90);

            // 덮어쓰기
            $im->writeImage($fullPath);

            $im->clear();
            $im->destroy();

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success',
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }

    // 법인저장
    public function saveCorp()
    {
        try {

            $vr_sq = $this->request->getPost('vr_sq');
            $atcl_no = $this->request->getPost('atcl_no');

            $this->model->saveCorp($vr_sq, $atcl_no);

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success',
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }

    // 파일업로드
    public function uploadFile()
    {
        $lib = new MyUpload();

        try {
            $usr_id = session('usr_id');
            $vr_sq = $this->request->getPost('vr_sq');



            $files = $this->request->getFiles();

            $uploadPath = "/upload/v2_file/" . $vr_sq . "/";

            $file = $files['files'];
            $arrUploadfile = [];
            $uploadData = $lib->do_upload2($file, $uploadPath);

            if ($uploadData !== false) {
                $arrUploadfile[] = $uploadData;
            }

            if (!empty($arrUploadfile)) {
                foreach ($arrUploadfile as $key => $uploadFile) {

                    $data = [
                        'vr_sq' => $vr_sq,
                        // 'file_sq' => $this->request->getPost('file_sq'),
                        'orig_name' => $uploadFile['origin_name'],
                        'new_name' => $uploadFile['file_name'],
                        'file_path' => $uploadPath, // 필요에 따라 상대경로로만 저장
                        'ext' => '.' . $uploadFile['ext'],
                        'size' => $file->getSize(),
                        'img_yn' => null,
                        'img_height' => null,
                        'img_width' => null,
                        'usr_id' => $usr_id,
                    ];

                    // print_r($data);
                    // exit;

                    // if (!empty($data)) {

                    // 파일업로드 정보 저장
                    $this->model->saveFileInfo($data);

                    // }
                }



            }

            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success'
            ]);


        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }

    }

    // 매물정보 저장
    public function saveRegi()
    {
        /*
            1.0.1 	POST 데이터 받기.
            1.1.1 	1차 검증인지 2차검증인지 확인.
            1.1.2 	1차, 2차 검증이면 v2_confirm.type에 넣을 값을 알맞게 셋팅.
            1.2.1 	v2_confirms에 데이터가 있는지 확인.
            1.3.1 	데이터가 있음 : success 여부 판단 후 updateConfirm 실행 success값만 UPDATE. (수정변경이력 저장)
            1.4.1 	데이터가 없음 : success 여부 판단 후 insertConfirm 실행 v2_confirms INSERT. (수정변경이력 저장)
            1.4.2 	상태변경 하기 : 등기부등본 확인중 상태로 변경. (수정변경이력 저장)
            1.5.1 	이미지파일 서버에 UPLOAD (수정변경이력 저장)
            1.6.1 	기존파일 탐색.
            1.7.1 	기존파일 있음 : 기존파일 use_yn 'N'으로 UPDATE 후 v2_files INSERT.
            1.8.1 	기존파일 없음 : v2_files INSERT.
            1.9.1 	매물주소, 의뢰인 정보 v2_check_list INSERT. (수정변경이력 저장)
            1.10.1 	API 전송.
            1.11.1	API 전송결과 : SUCCESS 이면 상태값 변경 : 등기부등본 확인완료 상태. (수정변경이력 저장)
        */

        $naver = new NaverApiClient();
        $model710 = new M710Model();
        $model415 = new M415Model();
        $v2DailyModel = new V2StDailyModel();

        try {

            $usr_id = session('usr_id');
            $toDay = date('Y-m-d H:i:s');
            $atcl_vrtc_way = 'R';													//검증구분
            $atcl_vr_sq = $this->request->getPost('rcpt_key');
            // 		$atcl_no			= $this->request->getPost('atcl_no');	
            $reg_conf_yn_1 = $this->request->getPost('reg_conf_yn_1');			//확인내용
            $reg_conf_yn_2 = $this->request->getPost('reg_conf_yn_2');			//매물주소
            $reg_conf_yn_3 = $this->request->getPost('reg_conf_yn_3');			//의뢰인정보
            $reg_conf_yn_info_2 = $this->request->getPost('reg_conf_yn_info_2');		//매물주소
            $reg_conf_yn_info_3 = $this->request->getPost('reg_conf_yn_info_3');		//의뢰인정보
            $memo = $this->request->getPost('memo');						//메모
            $owner_verifiable = $this->request->getPost('owner_verifiable');			//실소유주 확인여부
            $noimg_chk_chk = $this->request->getPost('noimg_chk_chk');			// 등기부등본이미지 파일없음.
            $img_chk_chk = $this->request->getPost('img_chk_chk');				// 등기소, 리얼탑 열람, 리얼탑 기열람, 열람
            $atcl_vrtc_type = $this->request->getPost('atcl_vrtc_type');			// 검증구분
            $vrfc_type_sub = $this->request->getPost('vrfc_type_sub');			// 하위검증구분
            $arr_uncnfrm_status = $this->request->getPost('arr_uncnfrm_status');		// 등기부등본 미확인여부 상세
            $try_cnt = '0';

            //상태가 이미 등기부등본확인중 이상이면 저장하지 않는다.
            $resStat = $this->model->chkStat($atcl_vr_sq);
            $v2_vrfc_req = $v2DailyModel->get_v2_vrfc_req($atcl_vr_sq);
            $rlet_type_cd = $model415->get_rlet_type_cd($atcl_vr_sq);

            if ($resStat['stat_cd'] >= '60' || $resStat['stat_cd'] == '19') {
                throw new \Exception('이미 저장된 데이터입니다.');
            } else {

                $resultCnt = $this->model->chkRegiTryCnt($atcl_vr_sq);	//1차검증인지 2차검증인지 확인 쿼리 : v2_vrfc_req.type_cnt
                if ($resultCnt['reg_try_cnt'] == 0) {			// 1차 검증일 때
                    log_message('debug', '705 page >> 매물번호 : ' . $atcl_vr_sq . ' 등기부등본 불일치 횟수 : 0 ');
                    $try_cnt = '1';
                } else if ($resultCnt['reg_try_cnt'] == 1) {	// 2차 검증일 때
                    log_message('debug', '705 page >> 매물번호 : ' . $atcl_vr_sq . ' 등기부등본 불일치 횟수 : 1 ');
                    $try_cnt = '2';
                } else {
                    log_message('debug', '705 page >> 매물번호 : ' . $atcl_vr_sq . ' 등기부등본 불일치 횟수 : 예외처리 ');
                    $try_cnt = '2';
                    //$try_cnt = intval($try_cnt) + 1;
                }

                $result = $this->model->chkConfirm($atcl_vr_sq, $atcl_vrtc_way);
                if ($result == 0) {	//v2_confirm 존재하지 않는다면
                    if ($reg_conf_yn_2 == '10000' && $reg_conf_yn_3 == '10000') { //success 여부 판단
                        $chk_type = '1';
                        //$chk_delay = '0'; //지연여부
                        //$chk_zombie = '0'; //좀비매물
                    } else {
                        // 2015.06.29 추가
                        // 불일치가 날 경우에 10분 이내에 다시 불일치 처리 불가능(같은 매물을 두사람이 중복처리할 가능성 사전 방지)
                        // 1. 현재 매물의 마지막으로 업데이트 된 시간을 가져옴.
                        // 2. 현재 시간과 비교하여 10분 이내면 경고창을 띄어줌.

                        $chk_type = '0';
                        //$chk_delay = '1'; //지연여부
                        //$chk_zombie = '0'; //좀비매물

                        $result_tm = $this->model->getUpdateFailTime($atcl_vr_sq);
                        $update_tm = $result_tm['insert_tm'];
                        $ten_ago = date("Y-m-d H:i:s", mktime(date("H"), date("i") - 1, date("s"), date("m"), date("d"), date("Y")));

                        if ($update_tm > $ten_ago) {
                            // 수정한 시간이 현재시간10분전 보다 클 경우 수정불가능
                            throw new \Exception('이미 불일치 처리 된 매물입니다.');
                        }
                    }

                    $this->model->insertConfirm($atcl_vr_sq, $atcl_vrtc_way, $chk_type, $try_cnt);
                } else {
                    if ($reg_conf_yn_2 == '10000' && $reg_conf_yn_3 == '10000') { //success 여부 판단
                        $chk_type = '1';
                        //$chk_delay = '0'; //지연여부
                        //$chk_zombie = '0'; //좀비매물
                    } else {
                        // 2015.06.29 추가
                        // 불일치가 날 경우에 10분 이내에 다시 불일치 처리 불가능(같은 매물을 두사람이 중복처리할 가능성 사전 방지)
                        // 1. 현재 매물의 마지막으로 업데이트 된 시간을 가져옴.
                        // 2. 현재 시간과 비교하여 10분 이내면 경고창을 띄어줌.

                        $chk_type = '0';
                        //$chk_delay = '1'; //지연여부
                        //$chk_zombie = '0'; //좀비매물

                        $result_tm = $this->model->getUpdateFailTime($atcl_vr_sq);
                        $update_tm = $result_tm['insert_tm'];
                        $ten_ago = date("Y-m-d H:i:s", mktime(date("H"), date("i") - 1, date("s"), date("m"), date("d"), date("Y")));

                        if ($update_tm > $ten_ago) {
                            throw new \Exception('이미 불일치 처리 된 매물입니다.');
                        }
                    }
                    $this->model->updateConfirm($atcl_vr_sq, $atcl_vrtc_way, $chk_type);
                }


                $this->model->InsResChar($atcl_vr_sq);	//담당자 업데이트

                // 모바일v1,v2고 등기부등본 미확인여부 상세 저장
                if ($vrfc_type_sub == 'M1' || $vrfc_type_sub == 'O1') {
                    $this->model->add_cert_uncnfrm_status($atcl_vr_sq, $arr_uncnfrm_status);
                    if (strpos($arr_uncnfrm_status, '20020') !== false) {  		//등기부등본 미확인여부 상세에  20020(파일 오첨부)있고
                        if ($vrfc_type_sub == 'M1') {	//	모바일v1일땐 코드 20020,코멘트x
                            $reg_conf_yn_2 = '20020';
                            $reg_conf_yn_info_2 = '';
                        } else {						//	모바일v2일땐 일반 불일치코드,코멘트=파일 오첨부
                            $reg_conf_yn_info_2 = '파일 오첨부';
                        }
                    }
                }

                //v2_check_list 확인여부 INSERT
                $this->model->insertChkList($atcl_vr_sq, $atcl_vrtc_way, '21', $reg_conf_yn_2, $reg_conf_yn_info_2);

                //v2_check_list 매물주소 INSERT
                $this->model->insertChkList($atcl_vr_sq, $atcl_vrtc_way, '22', $reg_conf_yn_3, $reg_conf_yn_info_3);

                //memo 저장
                $this->model->saveMemo([$memo, $atcl_vr_sq]);

                //실소유주 확인 저장
                $this->model->update_owner_verifiable($atcl_vr_sq, $owner_verifiable);


                $sendData = $this->model->getDatacertAPI($atcl_vr_sq, 'R');

                //이미지 파일 없음 && 홍보확인서 V2일 경우
                log_message('debug', '705 noimage_chk_chk sendData_return1 => ' . $sendData['atclNo'] . ' ::: ' . json_encode($sendData) . PHP_EOL);
                if ($noimg_chk_chk == "Y" && $sendData['vrfcType'] == "D2") {
                    // $sendData['ownerVerifiable'] = false;
                }

                $d_yn = $this->m710_model->get_send_yn('D');

                if ($d_yn['stop_yn'] == 'N') {	//전송금지
                    //1.해당매물정보를v2_stop_api_save_info에다 넣음
                    $model710->insert_v2_stop_api_save_info($sendData['atclNo'], $atcl_vr_sq, 'D', '');
                    //2.아무렇지않게 행동한다
                    $send_result['result'] = 'success';
                } else {
                    //API 호출
                    $send_result = $naver->certification($sendData['atclNo'], $try_cnt, $sendData['success'], $sendData['checkList'], $sendData['charger'], $sendData['date'], $sendData['modifyInfo'], $sendData['ownerVerifiable']);
                }

                if ($send_result['result'] == 'success') {
                    if ($chk_type == '1') {
                        //상태변경 TABLE INSERT : 등기부등본 확인완료 상태로 변경 
                        $result_query7 = $this->model->chgStat($atcl_vr_sq, '45', $toDay);
                        $chgVrfc45 = $this->model->chgStatVrfc($atcl_vr_sq, '45');	//v2_vrfc_req INSERT
                        $statFaxUp45 = $this->model->chgStatFax($atcl_vr_sq, '45');	//fax_imgs

                        //상태변경 TABLE INSERT : 검증완료 상태로 변경 
                        $result_query8 = $this->model->chgStat($atcl_vr_sq, '60', $toDay);
                        $chgVrfc60 = $this->model->chgStatVrfc($atcl_vr_sq, '60');	//v2_vrfc_req INSERT	
                        $statFaxUp60 = $this->model->chgStatFax($atcl_vr_sq, '60');	//fax_imgs

                        // ★ 검증완료
                        //0.불일치 이력이 있는지 확인
                        $cnt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                        if (empty($cnt)) {	//검증완료일땐 불일치가없어야 통계포함된다
                            if ($atcl_vrtc_type == 'M' || $atcl_vrtc_type == 'O') {	//모바일은 등기가 첨 시작이니까 insert해줘야함
                                if (!($atcl_vrtc_type == 'M' && in_array($rlet_type_cd['rlet_type_cd'], array('B01', 'B02', 'B03')))) {//만약 분양권들이면 넘어가고 아니면 체크
                                    //1.등기부등본 확인중 시간
                                    $tel_doc_conf_dt = $model415->get_cert_M_timeForHistory($atcl_vr_sq);
                                    //2.등기부등본 확인완료 시간
                                    $cert_comple_dt = $model415->get_cert_confTimeForHistory($atcl_vr_sq);
                                    //3.검증완료시간
                                    $finishTime = $model415->get_60_ForHistory($atcl_vr_sq);
                                    //4.해당 정보를 테이블에 넣는다
                                    $model415->insert_v2_time_required_M($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm'], $finishTime['insert_tm']);
                                }
                            } else {
                                //1.등기부등본 확인중 시간
                                $tel_doc_conf_dt = $model415->get_cert_ing_TimeForHistory($atcl_vr_sq);
                                //2.등기부등본 확인완료 시간
                                $cert_comple_dt = $model415->get_cert_confTimeForHistory($atcl_vr_sq);
                                //3.해당 정보를 테이블에 넣는다
                                $model415->update_v2_time_required_Conf_Done($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm']);
                            }
                        }
                        if ($noimg_chk_chk == 'Y') {
                            $this->model->chgStat($atcl_vr_sq, '70', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'Y');	// reg_status를 업데이트해준다.
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0103', '1', 'add');	// 등기부등본이미지 없음 저장
                        }
                        if ($img_chk_chk == 'O') {
                            $this->model->chgStat($atcl_vr_sq, '76', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'O');	// reg_status를 업데이트해준다.	
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0105', '1', 'add');	// (열람)간소화확인으로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0101', '1', 'add');	// 일치로 저장
                        } else if ($img_chk_chk == 'T') {
                            $this->model->chgStat($atcl_vr_sq, '80', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'T');	// reg_status를 업데이트해준다.	
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0111', '1', 'add');	// 등기소로 일치로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0101', '1', 'add');	// 일치로 저장							
                        } else if ($img_chk_chk == 'R') {
                            $this->model->chgStat($atcl_vr_sq, '86', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'R');	// reg_status를 업데이트해준다.	
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0107', '1', 'add');	// 리얼탑 열람 일치로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0101', '1', 'add');	// 일치로 저장
                        } else if ($img_chk_chk == 'G') {
                            $this->model->chgStat($atcl_vr_sq, '87', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'G');	// reg_status를 업데이트해준다.	
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0108', '1', 'add');	// 리얼탑 기열람 일치으로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0101', '1', 'add');	// 일치로 저장
                        }
                    } else {
                        if ($atcl_vrtc_type == 'M') {
                            //상태변경 TABLE INSERT : 등기부등본 확인 불일치 상태로 변경
                            $result_query7 = $this->model->chgStat($atcl_vr_sq, '49', $toDay);
                            $chgVrfc49 = $this->model->chgStatVrfc($atcl_vr_sq, '49');			//v2_vrfc_req INSERT
                            $statFaxUp49 = $this->model->chgStatFax($atcl_vr_sq, '49');		//fax_imgs	

                            //v2_vrfc_req try_cnt 값을 1로 update
                            $res_try = $this->model->chgRegiTryCnt($atcl_vr_sq, '2');

                            //상태변경 TABLE INSERT : 검증실패 상태로 변경.
                            $result_query9 = $this->model->chgStat($atcl_vr_sq, '69', $toDay);
                            $chgVrfc69 = $this->model->chgStatVrfc($atcl_vr_sq, '69');	//v2_vrfc_req INSERT
                            $statFaxUp69 = $this->model->chgStatFax($atcl_vr_sq, '69');	//fax_imgs

                            // ★모바일이고 검증실패
                            if (!in_array($rlet_type_cd['rlet_type_cd'], array('B01', 'B02', 'B03'))) {//만약 분양권들이면 넘어가고 아니면 체크
                                //1.등기부등본 확인중 시간
                                $tel_doc_conf_dt = $model415->get_cert_M_timeForHistory($atcl_vr_sq);
                                //2.등기부등본 확인실패 시간
                                $cert_comple_dt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                                //3.검증실패시간
                                $finishTime = $model415->get_69_ForHistory($atcl_vr_sq);
                                //4.해당 정보를 테이블에 넣는다
                                $model415->insert_v2_time_required_M($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm'], $finishTime['insert_tm']);
                            }
                        } else {
                            //상태변경 TABLE INSERT : 등기부등본 확인 불일치 상태로 변경
                            $result_query7 = $this->model->chgStat($atcl_vr_sq, '49', $toDay);
                            $chgVrfc49 = $this->model->chgStatVrfc($atcl_vr_sq, '49');			//v2_vrfc_req INSERT
                            $statFaxUp49 = $this->model->chgStatFax($atcl_vr_sq, '49');		//fax_imgs

                            //등기부등본 확인중 상태로 변경.
                            $result_query30 = $this->model->saveChangedHistory($atcl_vr_sq, '30', 'C9', $usr_id, '상태변경 : 49 => 30'); //검증결과 변동사항 HISTORY
                            $chgVrfc40 = $this->model->chgStatVrfc($atcl_vr_sq, '30');			//v2_vrfc_req INSERT
                            $statFaxUp40 = $this->model->chgStatFax($atcl_vr_sq, '30');		//fax_imgs

                            if ($try_cnt == '1') {
                                //v2_vrfc_req try_cnt 값을 1로 update
                                $this->model->chgRegiTryCnt($atcl_vr_sq, '1');
                                if ($atcl_vrtc_type == 'T') {
                                    //검증구분이 전화매물일 경우 사전에 일치로 처리된 값을 초기화 시켜준다.
                                    $this->model->resetTelConf($atcl_vr_sq);
                                }

                                // ★1차실패
                                if ($atcl_vrtc_type == 'O') {
                                    //1.등기부등본 확인중 시간
                                    $tel_doc_conf_dt = $model415->get_cert_M_timeForHistory($atcl_vr_sq);
                                    //2.등기부등본 확인실패 시간
                                    $cert_comple_dt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                                    //3.검증실패시간
                                    $finishTime = $model415->get_69_ForHistory($atcl_vr_sq);
                                    //4.해당 정보를 테이블에 넣는다
                                    $model415->insert_v2_time_required_M($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm'], $finishTime['insert_tm']);
                                } else {
                                    //1.등기부등본 확인중 시간
                                    $tel_doc_conf_dt = $model415->get_cert_ing_TimeForHistory($atcl_vr_sq);
                                    //2.등기부등본 확인실패 시간
                                    $cert_comple_dt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                                    //3.해당 정보를 테이블에 넣는다
                                    $sf = 'F';
                                    $model415->update_v2_time_required_Conf($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm'], $sf);
                                }
                            } else if ($try_cnt == '2') {
                                //v2_vrfc_req try_cnt 값을 2로 update
                                $this->model->chgRegiTryCnt($atcl_vr_sq, '2');

                                //상태변경 TABLE INSERT : 검증실패 상태로 변경.
                                $this->model->chgStat($atcl_vr_sq, '69', $toDay);
                                $this->model->chgStatVrfc($atcl_vr_sq, '69');	//v2_vrfc_req INSERT
                                $this->model->chgStatFax($atcl_vr_sq, '69');	//fax_imgs

                                // ★모바일 이외 검증실패
                                if ($atcl_vrtc_type == 'O') {
                                    //1.등기부등본 확인중 시간
                                    $tel_doc_conf_dt = $model415->get_cert_M_timeForHistory($atcl_vr_sq);
                                    //2.등기부등본 확인실패 시간
                                    $cert_comple_dt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                                    //3.검증실패시간
                                    $finishTime = $model415->get_69_ForHistory($atcl_vr_sq);
                                    //4.해당 정보를 테이블에 넣는다
                                    $model415->insert_v2_time_required_M($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm'], $finishTime['insert_tm']);
                                } else {
                                    //1.등기부등본 확인중 시간
                                    $tel_doc_conf_dt = $model415->get_cert_ing_TimeForHistory($atcl_vr_sq);
                                    //2.등기부등본 확인실패 시간
                                    $cert_comple_dt = $model415->get_cert_failTimeForHistory($atcl_vr_sq);
                                    //3.해당 정보를 테이블에 넣는다
                                    $model415->update_v2_time_required_Conf_Done($v2_vrfc_req['atcl_no'], $v2_vrfc_req['cpid'], $atcl_vrtc_type, $tel_doc_conf_dt['insert_tm'], $cert_comple_dt['insert_tm']);
                                }
                            }
                        }

                        if ($noimg_chk_chk == 'Y') {
                            $this->model->chgStat($atcl_vr_sq, '70', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'Y');	// reg_status를 업데이트해준다.
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0103', '1', 'add');	// 등기부등본이미지 없음 저장
                        }
                        if ($img_chk_chk == 'O') {
                            $this->model->chgStat($atcl_vr_sq, '77', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'O');	// reg_status를 업데이트해준다.
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0105', '1', 'add');	// (열람)간소화확인으로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0102', '1', 'add');	// 불일치로 저장
                        } else if ($img_chk_chk == 'T') {
                            $this->model->chgStat($atcl_vr_sq, '85', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'T');	// reg_status를 업데이트해준다.							
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0112', '1', 'add');	// 등기소 불일치로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0102', '1', 'add');	// 불일치로 저장							
                        } else if ($img_chk_chk == 'R') {
                            $this->model->chgStat($atcl_vr_sq, '88', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'R');	// reg_status를 업데이트해준다.
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0109', '1', 'add');	// 리얼탑 열람 불일치로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0102', '1', 'add');	// 불일치로 저장
                        } else if ($img_chk_chk == 'G') {
                            $this->model->chgStat($atcl_vr_sq, '89', $toDay);
                            $this->model->updateStat($atcl_vr_sq, 'G');	// reg_status를 업데이트해준다.
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0110', '1', 'add');	// 리얼탑 기열람 불일치로 저장
                            $v2DailyModel->set_v2_st_daily(NULL, $v2_vrfc_req['cpid'], 'R0102', '1', 'add');	// 불일치로 저장
                        }

                    }

                } else {
                    if (isset($send_result['error'])) {
                        $error_message = $send_result['error']['code'] . "\\n" . $send_result['error']['message'];

                        // API 호출 에러 발생시 해당 내용들을 DB에 저장해준다.
                        $err_time = date("Y-m-d H:i:s");
                        $this->model->saveApiErr($atcl_vr_sq, $send_result['error']['code'], $send_result['error']['message'], $err_time, $v2_vrfc_req['atcl_no']);
                        throw new \Exception($error_message);
                    } else {
                        throw new \Exception('네이버 전송 중 오류가 발생되었습니다. 다시 시도하세요.');
                    }
                }

            }

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }

    // 다음매물 확인
    public function getNextInfo()
    {
        try {

            $vr_sq = $this->request->getPost('vr_sq');

            $data = $this->model->getNextInfo($vr_sq);

            if (empty($data)) {
                return $this->response->setJSON([
                    'code' => '9',
                    'msg' => '등기부등본 이미지가 존재하지 않습니다.'
                ]);
            } else {
                return $this->response->setJSON([
                    'code' => '0',
                    'msg' => 'success',
                    'resw' => $data['vr_sq']
                ]);
            }


        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }
}